﻿namespace HeuristicLab.Problems.ProgramSynthesis {
  using HeuristicLab.Common;
  using HeuristicLab.Core;
  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

  [StorableClass]
  public class PlushEntry : Item {
    public PlushEntry() { }

    public PlushEntry(Expression instruction = null, int close = 0, bool silent = false) {
      Instruction = instruction;
      Close = close;
      Silent = silent;
    }

    [StorableConstructor]
    public PlushEntry(bool deserializing) : base(deserializing) { }

    public PlushEntry(PlushEntry origin, Cloner cloner) : base(origin, cloner) {
      Instruction = cloner.Clone(origin.Instruction);
      Close = origin.Close;
      Silent = origin.Silent;
    }

    [Storable]
    public Expression Instruction { get; set; }
    [Storable]
    public int Close { get; set; }
    [Storable]
    public bool Silent { get; set; }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new PlushEntry(this, cloner);
    }
  }
}
